;;function calc Kt wet from C, Hb, sigma*Hb, Kt dry, K water, W
;;input C: Soil organic carbon, Hb, sigma*Hb, Kt dry, K water, W
;;output Kt:Thermal conductivity in wet condition
function func_Kt, C, h_b, sigma_hb, W, Kt_dry
;;parameter setting
K_water = 0.6 ;; [W/m/K]

a0 = h_b - sigma_hb
a1 = a0 + C + W
if (a1 eq 0) then begin
  Kt = 0.
endif else begin
  a2 = a0 + C
  a3 = a2 / a1
	a4 = W / a1
  Kt = (Kt_dry * a3) + (K_water * a4)
endelse

  return, Kt
end

