;;function calc Kt dry from C, Hb, sigma*Hb
;;input C: Soil organic carbon, Hb,sigma*Hb
;;output Kt dry:Thermal conductivity in dry condition
function func_Kt_dry, C, h_b, sigma_hb
;;parameter setting
Kc_inf=0.01D0
Kt0 = 1.2D0
C_inf = 1500.D0

a0 = h_b - sigma_hb
a1 = a0 + C
if (a1 eq 0) then begin
  Kt = 0.
endif else begin
  a2 = C / a1
  a3 = a0 /a1
  Kt = (Kc_inf * a2) + (Kt0 * a3)
endelse

  return, Kt
end

