;;function calc LF 
;;input Ta, Pr
;;output LF
function func_exp_Ta, a1, b, T1, Ta
  pwr = 4.
  lf1_ta = a1 * exp(-1. * abs(Ta - T1) ^ pwr / b)

  return, lf1_ta
end

function func_log_Pr, Pr0
  pwr = 5.
  a =  1.2
  Pr_adjust = 160.0
  Pr = Pr0 + Pr_adjust
  aa1 = Pr/exp(pwr)
  aa2 = alog(aa1)
  lf1_pr = a * aa2

  return, lf1_pr
end

function func_LF, Ta, Pr, LFparam

difobs = 4.151065 ;;VISIT
lf_min = 0.1
lf_max = 4.2

;;parameters for LF
a1 = LFparam[0]
b1 = LFparam[1]
b2 = LFparam[2]
T1 = LFparam[3]

if (Ta le T1) then b0 = b1 $
else b0 = b2
b = 4. * b0

lf_ta = func_exp_Ta(a1, b, T1, Ta)
lf_pr = func_log_Pr(Pr) / difobs
lf00 = (lf_ta * lf_pr) * difobs

if (lf00 lt lf_min) then begin
  lf0 = lf_min
endif else if (lf00 lt lf_max) then begin
  lf0 = lf00
endif else begin
  lf0 = lf_max
endelse

  return, lf0
end

  
