;;function calc TDD & FDD from Tav & Tamp
;;input Tav:Ta mean, Tamp:Ta amplitude
;;output TDD. FDD
function func_calc_TFDD, Tav, Tamp
  PI = 3.14159265
  rad = PI/180.
  thresh_val = 0.
  nday = 360
  missing = -999
  TDD = missing
  FDD = missing
  
  aa1 = findgen(nday)
  aa2 = sin(aa1[*]*rad)
  aa3 = Tamp # aa2[*]
  T1 = Tav[0] + aa3[*]

n1 = n_elements(aa1)
n2 = n_elements(aa2)
n3 = n_elements(aa3)
nt1 = n_elements(T1)
if (n1 ne nday) then print,'aa1 error'
if (n2 ne nday) then print,'aa2 error'
if (n3 ne nday) then print,'aa3 error'
if (nt1 ne nday) then print,'T1 error'

  idx_TDD = where(T1 ge thresh_val, cnt_TDD)
  idx_FDD = where(T1 lt thresh_val, cnt_FDD)
  if(cnt_TDD eq 0) then TDD = 0 $
  else if(cnt_TDD gt 0) then TDD = total(T1[idx_TDD])
  if(cnt_FDD eq 0) then FDD = 0 $
  else if(cnt_FDD gt 0) then FDD = -1.*total(T1[idx_FDD])
  result = [TDD, FDD]

  return, result
end

