;function judge area1,2,3,4,5
function judge_area, lon, lat
  lat1 = 68
  lon1 = 120
  lon2 = 245
  lon3 = 330
  lon4 = 40
  if (lat gt lat1) then begin
    area = 1
  endif else begin
    if(lon1 lt lon and lon le lon2) then area = 2 $
    else if(lon2 lt lon and lon le lon3) then area = 3 $
    else if(lon4 lt lon and lon le lon1) then area = 5 $
    else if((lon3 lt lon and lon le 360) or $
            (0 lt lon and lon le lon4)) then area = 4
  endelse

  return, area 
end

;function judge warm or cold
function judge_warmcold, year
  year1 = -125000
  year2 = -113000
  year3 = -12000
  year4 = 0
  if ((year lt year1) or (year gt year4)) then begin
    print, 'func_calc_Tamp err over time span year should be in -125000-0'
  endif else begin
    if(year1 le year and year lt year2) then warmcold = 'w' $
    else if(year2 le year and year le year3) then warmcold = 'c' $
    else if(year3 lt year and year le year4) then warmcold = 'w'
  endelse

  return, warmcold
end

;;
;;function calc Tamp from Tav, dist, lon, lat, year_age
;;input Tav:Ta mean,Lat:latitude,Lon,longitude,
;;output Tamp:Ta amplitude
function func_calc_Tamp, Tav, dist, lon, lat, year_age
;;warm from ERA-I
  ABC_warmls = [ $
               [-1.0433926757, 0.0229786299, 27.6165483463], $
               [-1.4578664526, 0.0154903768, 32.9475331448], $
               [-0.8207506752, 0.0065853428, 34.8727651069], $
               [-1.4097861384, 0.0066006897, 29.8647723072], $
               [-1.6269077809, 0.0071347927, 32.9053289961] $
               ]
;; cold  from 3 median CCSM4, MPI-ESM-P and MRI-CGCM3
  ABC_coldls = [ $
               [-0.2506379187, 0.0116648868, 35.661303513], $
               [-1.125462881, 0.0107519043, 27.2216705429], $
               [-0.7220778963, -0.01256991, 26.8157832816], $
               [-1.1994410773, 0.0096277091, 20.1080677271], $
               [-0.7219246383, 0.0003046349, 44.1998315422] $
               ]
  
  area = judge_area(lon, lat)
  idx_area = fix(area) - 1
  warmcold = judge_warmcold(year_age)
  if (warmcold eq 'w') then ABCls = ABC_warmls $
  else if (warmcold eq 'c') then ABCls = ABC_coldls
  a = ABCls[0, idx_area]
  b = ABCls[1, idx_area]
  c = ABCls[2, idx_area]

  aa1 = a * Tav
  aa2 = b * dist
  Tamp = (aa1+ aa2+ c) /2.
  
  return, Tamp
end
