;;function calc d(active layer) from Kt, FDD, rho
;;input df:thermal conductivity as freezing, Kt:thermal conductivity as freezing, FDD
;;output dn
function func_df, Kt, FDD, rho
;parameter setting
;;rho=500.
L=3.34e5
time_unit = 24*60*60
zero_val = 1.e-4
m2mm = 1.e3

if (rho lt zero_val) then rho = zero_val

a1 = 2.*Kt*(FDD*time_unit)
a2 = rho*L
df = m2mm * (a1/a2)^0.5

  return, df
end

