;;function calc gzai from Ta
;;input soil, Ta
;;output gzai_evap,gzai_Qs,gzai_Qsb,gzai

function func_logistics, flg_rev, t0, A, B, C, Xa, missing
;  Xamin = -25.
  Xamax = 15.

  if (flg_rev eq 0) then begin
    t0_0 = Xamax-t0
    Xa_0 = Xamax-Xa
  endif else if (flg_rev eq 1) then begin
    t0_0 = t0
    Xa_0 = Xa
  endif

  a1 = C * (Xa_0 - t0_0)
  a2 = exp(a1)
  a3 = A * a2
  a4 = 1. + a2
  gzai = (a3 / a4) - B

  return, gzai
end


function func_gzai1, num_PF, soil, Xa, missing

  param_Evapls = [ [1.50, 0.38, -0.50, 0.30], $
                 [-3.5, 0.35, -0.57, 0.5], $
                 [-11.5, 0.39, -0.55, 0.7] ]

  param_Qsls = [0.06, 0.05, 0.04, 1.0]
  
  adj_t0_Qsb = 2.8
  param_Qsbls = [ [-1.5+adj_t0_Qsb, 0.38, -0.06, 0.30	], $
                [-6.42857+adj_t0_Qsb, 0.34, -0.03, 0.5], $
                [-14.0+adj_t0_Qsb, 0.33, -0.02, 0.8] ]
  param_Qsbls = [0.06, 0.03, 0.02, 0.0]

if (1 le soil and soil le 13) then begin
  if (1 le soil and soil le 4) then begin
;;1-4 sand
    idx_soil = 0
  endif else if (5 le soil and soil le 8) then begin
;;5-8 silt
    idx_soil = 1
  endif else if (9 le soil and soil le 13) then begin
;;9-12 clay 13:Organic Materilas count as clay
    idx_soil = 2
  endif


;;Evap
  flg_rev0 = 1
  t0_evap = param_Evapls[0, idx_soil]
  A_evap = param_Evapls[1, idx_soil]
  B_evap = param_Evapls[2, idx_soil]
  C_evap = param_Evapls[3, idx_soil]
  Evap = func_logistics(flg_rev0, t0_evap, A_evap, B_evap, C_evap, Xa, missing)

;;Qs dash
    Qs = param_Qsls[idx_soil]
    Qsb = param_Qsbls[idx_soil]

;;frozen or not
    if (num_PF eq 1) then gamma = 0.9 $
    else if (num_PF eq 2) then gamma = 0.5 $
    else if (3 le num_PF and num_PF le 5) then gamma = 0.0 $
    else gamma = 0.0

    Qs_dash = Qs + (gamma * Qsb)
    gzai1 = Evap + Qs_dash

endif else if (soil eq 15) then begin
;;15:bedrock count as bedrock=1
  idx_soil = 3  
  Evap = 0.0
  Qs = param_Qsls[idx_soil]
  Qsb = param_Qsbls[idx_soil]
  Qs_dash = Qs + Qsb
  gzai1 = Evap+Qs_dash
endif else begin
  Evap = 0.0
  Qs = 0.0
  Qsb = 1.0
  Qs_dash = Qs + Qsb
  gzai1 = Evap+Qs_dash
endelse

dat_gzai = [Evap, Qs_dash, Qsb, gzai1]

return, dat_gzai
end

