;;function calc rho from W
;;input W0:Water
;;output rho:soil density
function func_kai_Ihb, I00, h_b, I_hb, sigma_hb

;;limit Ice contribution for Kf-evaluation
if (I_hb gt 1) then begin
  I_hb = 1.
endif else if (I_hb ge 0) then begin
  I_hb = I_hb
endif else I_hb = 0.

if (I00 gt sigma_hb) then begin
  a0 = h_b-sigma_hb
  a1 = a0 + I00
  if (a1 eq 0) then kai_Ihb = 0 $
  else kai_Ihb = I00 / a1
endif else if (0 le I00 and I00 le sigma_hb) then begin
  kai_Ihb = I_hb
endif else begin
print,'rho_s error I00 <0 ==', I00, h_b, I_hb, sigma_hb
  kai_Ihb = 1.e-4
endelse

  return, kai_Ihb
end

