;;function make LF parameters
;;input CO2
;;output LF parameters
function func_line, a, b, x
  y = a*x+b
  return, y
end

function func_make_LFparam, CO2

b1 = 4.5e5
c1 = 2.0e9
c2 = 4.5e10
T1 = 25.0
P1 = 2000.0
paramls=['a1', 'a2', 'b2']
line_paramls = [ $
[-1.00e-3, 8.08e-1], $
[7.59e-5, 9.39e-1], $
[3.19e-3, 2.14] $
]

foreach each_param, paramls, idx_param do begin
;;calc a1, a2 b2
  a = line_paramls[0, idx_param]
  b = line_paramls[1, idx_param]
  y1 = func_line(a, b, CO2)

  case each_param of
    'a1':begin
      a1 = 1. - y1^3.
    end
    'a2':begin
      a2 = y1
    end
    'b2':begin
      b2 = 10.^y1
    end
  endcase
endforeach ;;each_param

LFparam = [a1,b1,b2,T1]
  return, LFparam
end

  
