;;function calc phy_tilda from df,dt,beta,W0,I00
;;input df:frozen active layer,dt:thermal active layer,W:water
;;output phy:difference between df and dt
function func_phy, df, dt, beta0, W0, I00, h_b, num_pf, missing
;parameter setting
;;h_b = 3000 ;;mm
adj_phy = 0.02 ;;in the case of SF,IF,NF, ice flow out to water
beta_sw = [2.0, 1.0]

dif_dfdt = df-dt
if (dif_dfdt gt 0) then beta = beta0 * beta_sw[1] $
else beta = beta0 * beta_sw[0]

tmp1 = beta*dif_dfdt
tmp2 = W0/h_b
phy_tilda = tmp1*tmp2

W01 = W0
I01 = -1.*I00

if (phy_tilda lt I01) then phy = I01 $
else if (phy_tilda le W01) then phy = phy_tilda $
else phy = W01

if (3 le num_pf and num_pf le 5) then phy = phy - (I00 * adj_phy)


return, phy
end

