;;function calc r array as n-1
;;input num_pf, tau, W_rate
;;output tau

function func_r_array, r_l_n, r_l_n1, r_o_n, r_o_n1, r_i_n, r_i_n1
;;make 3x3 array of r_land,ocean,ice

  dr_l = r_l_n - r_l_n1
  dr_o = r_o_n - r_o_n1
  dr_i =  r_i_n - r_i_n1

;land ice decreasing
  if (dr_i lt 0 or (r_i_n eq 0 and r_i_n1 eq 0)) then begin
    dr_1_r_i_n = 1.-r_i_n
    dr_1_r_i_n1 = 1.-r_i_n1

;ocean decreasing
    if (r_o_n eq 0) then begin
      denomi = r_l_n*dr_1_r_i_n
      ar00 = (r_l_n1*dr_1_r_i_n1) / denomi
      ar10 = (dr_l*dr_1_r_i_n1) / denomi

      denomi = dr_1_r_i_n
      ar20 = (-1.*dr_i) / denomi
      ar11 = dr_1_r_i_n1 / denomi
      ar21 = (-1.*dr_i) / denomi

      ar01 = 0.
      ar02 = 0.
      ar12 = 0.
      ar22 = 1.
      ar22 = 1.

    endif else if (r_o_n eq 1) then begin
      denomi = dr_1_r_i_n
      ar00 = dr_1_r_i_n1 / denomi
      ar20 = (-1.*dr_i) / denomi
      ar21 = (-1.*dr_i) / denomi
      
      denomi = r_o_n*dr_1_r_i_n
      ar01 = (dr_o*dr_1_r_i_n1) / denomi
      ar11 = (r_o_n1*dr_1_r_i_n1) / denomi

      ar10 = 0.
      ar02 = 0.
      ar12 = 0.
      ar22 = 1.
      ar22 = 1.

    endif else if (dr_o le 0) then begin
      denomi = r_l_n*dr_1_r_i_n
      ar00 = (r_l_n1*dr_1_r_i_n1) / denomi
      ar10 = (dr_l*dr_1_r_i_n1) / denomi

      denomi = dr_1_r_i_n
      ar20 = (-1.*dr_i) / denomi
      ar11 = dr_1_r_i_n1 / denomi
      ar21 = (-1.*dr_i) / denomi

      ar01 = 0.
      ar02 = 0.
      ar12 = 0.
      ar22 = 1.

    endif else if (dr_o gt 0) then begin
      denomi = dr_1_r_i_n
      ar00 = dr_1_r_i_n1 / denomi
      ar20 = (-1.*dr_i) / denomi
      ar21 = (-1.*dr_i) / denomi
      
      denomi = r_o_n*dr_1_r_i_n
      ar01 = (dr_o*dr_1_r_i_n1) / denomi
      ar11 = (r_o_n1*dr_1_r_i_n1) / denomi

      ar10 = 0.
      ar02 = 0.
      ar12 = 0.
      ar22 = 1.
     
    endif else print, 'r_array err1 =', r_l_n, r_l_n1, r_o_n, r_o_n1, r_i_n, r_i_n1
  endif else if (dr_i ge 0 or (r_i_n eq 1 and r_i_n1 eq 1)) then begin
;ocean decreasing
    if (r_o_n eq 0) then begin
      denomi = r_l_n
      ar00 = r_l_n1 / denomi
      ar10 = dr_l / denomi

      denomi = r_i_n
      ar02 = (dr_i*r_l_n1) / denomi
      ar12 = (dr_i*r_o_n1) / denomi
      ar22 = r_i_n1 / denomi

      ar20 = 0.
      ar01 = 0.
      ar11 = 1.
      ar21 = 0.
      ar22 = 1.

    endif else if (r_o_n eq 1) then begin
      denomi = r_o_n
      ar01 = dr_o / denomi
      ar11 = r_o_n1 / denomi

      denomi = r_i_n
      ar02 = (dr_i*r_l_n1) / denomi
      ar12 = (dr_i*r_o_n1) / denomi
      ar22 = r_i_n1 / denomi

      ar00 = 1.
      ar10 = 0.
      ar20 = 0.
      ar21 = 0.

    endif else if (dr_o le 0) then begin
      denomi = r_l_n
      ar00 = r_l_n1 / denomi
      ar10 = dr_l / denomi

      denomi = r_i_n
      ar02 = (dr_i*r_l_n1) / denomi
      ar12 = (dr_i*r_o_n1) / denomi
      ar22 = r_i_n1 / denomi

      ar20 = 0.
      ar01 = 0.
      ar11 = 1.
      ar21 = 0.

    endif else if (dr_o gt 0) then begin
      denomi = r_o_n
      ar01 = dr_o / denomi
      ar11 = r_o_n1 / denomi

      denomi = r_i_n
      ar02 = (dr_i*r_l_n1) / denomi
      ar12 = (dr_i*r_o_n1) / denomi
      ar22 = r_i_n1 / denomi

      ar00 = 1.
      ar10 = 0.
      ar20 = 0.
      ar21 = 0.

    endif else print, 'r_array err2 =', r_l_n, r_l_n1, r_o_n, r_o_n1, r_i_n, r_i_n1
  endif else print, 'r_array err3 =', r_l_n, r_l_n1, r_o_n, r_o_n1, r_i_n, r_i_n1
  
  r_area = [[ar00, ar10, ar20], [ar01, ar11, ar21], [ar02, ar12, ar22]] 

  return, r_area
end

