;;function calc tar
;;input num_pf, tau, W_rate
;;output tau

function func_tau, num_pf, tau0, W_rate, missing
;parameter setting
  tau_CP_max = 2500
  tau_EP_max = 1500
  tau_CP_min = tau_CP_max / 2.
  tau_EP_min = tau_EP_max / 2.
  tau_CP_mid = tau_CP_min + (tau_CP_max - tau_CP_min) / 2.
  tau_EP_mid = tau_EP_min + (tau_EP_max - tau_EP_min) / 2.
  thetals = [0.0, 0.3, 0.65, 1.01]
  CPls = [tau_CP_min, tau_CP_mid, tau_CP_max]
  EPls = [tau_EP_min, tau_EP_mid, tau_EP_max]

  no_theta = n_elements(thetals)
idx_tau0 = -1
  for i = 0, (no_theta-1)-1 do begin
    if (thetals[i] le W_rate and W_rate lt thetals[i+1]) then begin
      idx_tau0 = i
      break
    endif
  endfor ;;i


  if (tau0 gt tau_CP_max) then begin
    tau = tau0
  endif else if (tau0 gt tau_EP_max) then begin
    if (num_pf eq 1) then begin
      tau = tau_CP_max
    endif else begin
      tau = tau0
    endelse
  endif else begin
    if (num_pf eq 1) then begin
      tau = CPls[idx_tau0]
    endif else if (num_pf eq 2) then begin
      tau = EPls[idx_tau0]
    endif else begin
      tau = tau0
    endelse
  endelse

return, tau
end

