;;function write sav, netCDF, CSV, spinnup 
;;input variables
;;output sav
pro func_write, $
   missing, flg_restart, readme, $
   tlen, no_yr_all, no_I0W0, no_lp, $
   f_out_sav, f_out_nc, f_out_csv, f_spnnp_out_csv, $
   time_ice, time125k, $
   hgt_icethick, r_land, r_ocean, r_icecover, $
   dist, oaff, mapid, $
   Ta, Pr, critK, k, tau, CO2, lf, soc, $
   Tamp, TDD, FDD, FDD_snow, numPF, $
   gzai_1, gzai_2, Evap, Qs, $
   Kt_dry, Kt, Kf, rho_s, rho_l, dt, df, phy, $
   ICE, water, I0W0, $
   C_land, C_Ocean, C_icecover, $
   W_land, W_Ocean, W_icecover, $
   I_land, I_Ocean, I_icecover, $
   alt, $
   SOC_spnnp, Water_spnnp, ICE_spnnp, $
   critK_spnnp, k_spnnp, $
   Kt_dry_spnnp, Kt_spnnp, Kf_spnnp, $
   dt_spnnp, df_spnnp, phy_spnnp, $
   rho_s_spnnp, rho_l_spnnp, $
   C_land_spnnp, C_ocean_spnnp, C_icecover_spnnp, $
   W_land_spnnp, W_ocean_spnnp, W_icecover_spnnp, $
   I_land_spnnp, I_ocean_spnnp, I_icecover_spnnp, $
   gzai_1_spnnp, gzai_2_spnnp, Evap_spnnp, Qs_spnnp, $
   time_spnnp

;;write sav file
if (flg_restart eq 0) then begin
    save, $
       time_ice, time125k, $
       hgt_icethick, r_land, r_ocean, r_icecover, $
       dist, oaff, mapid, $
       Ta, Pr, critK, k, tau, CO2, lf, soc, $
       Tamp, TDD, FDD, FDD_snow, numPF, $
       gzai_1, gzai_2, Evap, Qs, $
       Kt_dry, Kt, Kf, rho_s, rho_l, dt, df, phy, $
       ICE, water, I0W0, $
       C_land, C_Ocean, C_icecover, $
       W_land, W_Ocean, W_icecover, $
       I_land, I_Ocean, I_icecover, $
       alt, $
       SOC_spnnp, Water_spnnp, ICE_spnnp, $
       critK_spnnp, k_spnnp, $
       Kt_dry_spnnp, Kt_spnnp, Kf_spnnp, $
       dt_spnnp, df_spnnp, phy_spnnp, $
       rho_s_spnnp, rho_l_spnnp, $
       C_land_spnnp, C_ocean_spnnp, C_icecover_spnnp, $
       W_land_spnnp, W_ocean_spnnp, W_icecover_spnnp, $
       I_land_spnnp, I_ocean_spnnp, I_icecover_spnnp, $
       gzai_1_spnnp, gzai_2_spnnp, Evap_spnnp, Qs_spnnp, $
       time_spnnp, $
       file = f_out_sav
endif else begin
    save, $
       time_ice, time125k, $
       hgt_icethick, r_land, r_ocean, r_icecover, $
       dist, oaff, mapid, $
       Ta, Pr, critK, k, tau, CO2, lf, soc, $
       Tamp, TDD, FDD, FDD_snow, numPF, $
       gzai_1, gzai_2, Evap, Qs, $
       Kt_dry, Kt, Kf, rho_s, rho_l, dt, df, phy, $
       ICE, water, $
       C_land, C_Ocean, C_icecover, $
       W_land, W_Ocean, W_icecover, $
       I_land, I_Ocean, I_icecover, $
       alt, $
       file = f_out_sav
endelse

;;;write nc file
;;Set up the file & handler
fid = ncdf_create(f_out_nc, /CLOBBER, /NETCDF4_FORMAT)

if (flg_restart eq 0) then n = 5 $
else n = 3
d = indgen(n, /LONG)
;;Set Dimension
d[0] = ncdf_dimdef(fid, 'len_str', max(strlen(readme)))
d[1] = ncdf_dimdef(fid, 'tlen', tlen)
d[2] = ncdf_dimdef(fid, 'no_yr', no_yr_all)
if (flg_restart eq 0) then begin
  d[3] = ncdf_dimdef(fid, 'I0W0', no_I0W0)
  d[4] = ncdf_dimdef(fid, 'no_loop', no_lp)
endif ;;flg_restart==1

;;Define variables to be stored
var_id = ncdf_vardef(fid, 'readme', d[0], /char)
var_id = ncdf_vardef(fid, 'time_ice', d[1], /float)
var_id = ncdf_vardef(fid, 'Time125k', d[2], /float)
var_id = ncdf_vardef(fid, 'hgt_icethick', d[2], /float)
var_id = ncdf_vardef(fid, 'r_land', d[2], /float)
var_id = ncdf_vardef(fid, 'r_ocean', d[2], /float)
var_id = ncdf_vardef(fid, 'r_icecover', d[2], /float)
var_id = ncdf_vardef(fid, 'dist', d[2], /float)
var_id = ncdf_vardef(fid, 'oaff', d[2], /float)
var_id = ncdf_vardef(fid, 'mapid', d[2], /float)
var_id = ncdf_vardef(fid, 'Ta', d[2], /float)
var_id = ncdf_vardef(fid, 'Pr', d[2], /float)
var_id = ncdf_vardef(fid, 'critK', d[2], /float)
var_id = ncdf_vardef(fid, 'K', d[2], /float)
var_id = ncdf_vardef(fid, 'tau', d[2], /float)
var_id = ncdf_vardef(fid, 'LF', d[2], /float)
var_id = ncdf_vardef(fid, 'CO2', d[2], /float)
var_id = ncdf_vardef(fid, 'Tamp', d[2], /float)
var_id = ncdf_vardef(fid, 'TDD', d[2], /float)
var_id = ncdf_vardef(fid, 'FDD', d[2], /float)
var_id = ncdf_vardef(fid, 'FDD_snow', d[2], /float)
var_id = ncdf_vardef(fid, 'numPF', d[2], /float)
var_id = ncdf_vardef(fid, 'gzai_1', d[2], /float)
var_id = ncdf_vardef(fid, 'gzai_2', d[2], /float)
var_id = ncdf_vardef(fid, 'Evap', d[2], /float)
var_id = ncdf_vardef(fid, 'Qs', d[2], /float)
var_id = ncdf_vardef(fid, 'Kt_dry', d[2], /float)
var_id = ncdf_vardef(fid, 'Kt', d[2], /float)
var_id = ncdf_vardef(fid, 'Kf', d[2], /float)
var_id = ncdf_vardef(fid, 'rho_s', d[2], /float)
var_id = ncdf_vardef(fid, 'rho_l', d[2], /float)
var_id = ncdf_vardef(fid, 'dt', d[2], /float)
var_id = ncdf_vardef(fid, 'df', d[2], /float)
var_id = ncdf_vardef(fid, 'phy', d[2], /float)
var_id = ncdf_vardef(fid, 'C_land', d[2], /float)
var_id = ncdf_vardef(fid, 'C_ocean', d[2], /float)
var_id = ncdf_vardef(fid, 'C_icecover', d[2], /float)
var_id = ncdf_vardef(fid, 'SOC', d[2], /float)
var_id = ncdf_vardef(fid, 'I_land', d[2], /float)
var_id = ncdf_vardef(fid, 'I_ocean', d[2], /float)
var_id = ncdf_vardef(fid, 'I_icecover', d[2], /float)
var_id = ncdf_vardef(fid, 'ICE', d[2], /float)
var_id = ncdf_vardef(fid, 'W_land', d[2], /float)
var_id = ncdf_vardef(fid, 'W_ocean', d[2], /float)
var_id = ncdf_vardef(fid, 'W_icecover', d[2], /float)
var_id = ncdf_vardef(fid, 'WATER', d[2], /float)
var_id = ncdf_vardef(fid, 'alt', d[2], /float)

if (flg_restart eq 0) then begin
  var_id = ncdf_vardef(fid, 'I0W0', d[3], /float)
  var_id = ncdf_vardef(fid, 'SOC_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'Water_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'ICE_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'critK_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'k_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'Kt_dry_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'Kt_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'Kf_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'dt_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'df_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'phy_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'rho_s_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'rho_l_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'C_land_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'C_ocean_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'C_icecover_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'W_land_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'W_ocean_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'W_icecover_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'I_land_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'I_ocean_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'I_icecover_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'gzai_1_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'gzai_2_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'Evap_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'Qs_spnnp', d[4], /float)
  var_id = ncdf_vardef(fid, 'time_spnnp', d[4], /float)
endif ;;flg_restart==1

;;Change modes0
ncdf_control, fid, /ENDEF
;;Write the data
ncdf_varput, fid, 'readme', readme
ncdf_varput, fid, 'time_ice', time_ice
ncdf_varput, fid, 'Time125k', time125k
ncdf_varput, fid, 'hgt_icethick', hgt_icethick
ncdf_varput, fid, 'r_land', r_land
ncdf_varput, fid, 'r_ocean', r_ocean
ncdf_varput, fid, 'r_icecover', r_icecover
ncdf_varput, fid, 'dist', dist
ncdf_varput, fid, 'oaff', oaff
ncdf_varput, fid, 'mapid', mapid
ncdf_varput, fid, 'Ta', Ta
ncdf_varput, fid, 'Pr', Pr
ncdf_varput, fid, 'K', K
ncdf_varput, fid, 'tau', tau
ncdf_varput, fid, 'LF', LF
ncdf_varput, fid, 'CO2', CO2
ncdf_varput, fid, 'Tamp', Tamp
ncdf_varput, fid, 'TDD', TDD
ncdf_varput, fid, 'FDD', FDD
ncdf_varput, fid, 'FDD_snow', FDD_snow
ncdf_varput, fid, 'numPF', numPF
ncdf_varput, fid, 'gzai_1', gzai_1
ncdf_varput, fid, 'gzai_2', gzai_2
ncdf_varput, fid, 'Evap', Evap
ncdf_varput, fid, 'Qs', Qs
ncdf_varput, fid, 'Kt_dry', Kt_dry
ncdf_varput, fid, 'Kt', Kt
ncdf_varput, fid, 'Kf', Kf
ncdf_varput, fid, 'rho_s', rho_s
ncdf_varput, fid, 'rho_l', rho_l
ncdf_varput, fid, 'dt', dt
ncdf_varput, fid, 'df', df
ncdf_varput, fid, 'phy', phy
ncdf_varput, fid, 'C_land', C_land
ncdf_varput, fid, 'C_ocean', C_ocean
ncdf_varput, fid, 'C_icecover', C_icecover
ncdf_varput, fid, 'SOC', SOC
ncdf_varput, fid, 'I_land', I_land
ncdf_varput, fid, 'I_ocean', I_ocean
ncdf_varput, fid, 'I_icecover', I_icecover
ncdf_varput, fid, 'ICE', ICE
ncdf_varput, fid, 'W_land', W_land
ncdf_varput, fid, 'W_ocean', W_ocean
ncdf_varput, fid, 'W_icecover', W_icecover
ncdf_varput, fid, 'WATER', WATER
ncdf_varput, fid, 'alt', alt

if (flg_restart eq 0) then begin
  ncdf_varput, fid, 'I0W0', I0W0
  ncdf_varput, fid, 'SOC_spnnp', SOC_spnnp
  ncdf_varput, fid, 'Water_spnnp', Water_spnnp
  ncdf_varput, fid, 'ICE_spnnp', ICE_spnnp
  ncdf_varput, fid, 'critK_spnnp', critK_spnnp
  ncdf_varput, fid, 'k_spnnp', k_spnnp
  ncdf_varput, fid, 'Kt_dry_spnnp', Kt_dry_spnnp
  ncdf_varput, fid, 'Kt_spnnp', Kt_spnnp
  ncdf_varput, fid, 'Kf_spnnp', Kf_spnnp
  ncdf_varput, fid, 'dt_spnnp', dt_spnnp
  ncdf_varput, fid, 'df_spnnp', df_spnnp
  ncdf_varput, fid, 'phy_spnnp', phy_spnnp
  ncdf_varput, fid, 'rho_s_spnnp', rho_s_spnnp
  ncdf_varput, fid, 'rho_l_spnnp', rho_l_spnnp
  ncdf_varput, fid, 'C_land_spnnp', C_land_spnnp
  ncdf_varput, fid, 'C_ocean_spnnp', C_ocean_spnnp
  ncdf_varput, fid, 'C_icecover_spnnp', C_icecover_spnnp
  ncdf_varput, fid, 'W_land_spnnp', W_land_spnnp
  ncdf_varput, fid, 'W_ocean_spnnp', W_ocean_spnnp
  ncdf_varput, fid, 'W_icecover_spnnp', W_icecover_spnnp
  ncdf_varput, fid, 'I_land_spnnp', I_land_spnnp
  ncdf_varput, fid, 'I_ocean_spnnp', I_ocean_spnnp
  ncdf_varput, fid, 'I_icecover_spnnp', I_icecover_spnnp
  ncdf_varput, fid, 'gzai_1_spnnp', gzai_1_spnnp
  ncdf_varput, fid, 'gzai_2_spnnp', gzai_2_spnnp
  ncdf_varput, fid, 'Evap_spnnp', Evap_spnnp
  ncdf_varput, fid, 'Qs_spnnp', Qs_spnnp
  ncdf_varput, fid, 'time_spnnp', time_spnnp
endif ;;flg_restart==1

;;Close the file & release the handler
ncdf_close, fid


headerls = [$
           'time125k', $
           'hgt_icethick', 'r_land', 'r_ocean', 'r_icecover', $
           'dist', 'oaff', 'mapid', $
           'Ta', 'Pr', 'critK', 'k', 'tau', 'CO2', 'lf', 'soc', $
           'Tamp', 'TDD', 'FDD', 'FDD_snow', 'numPF', $
           'gzai_1', 'gzai_2', 'Evap', 'Qs', $
           'Kt_dry', 'Kt', 'Kf', 'rho_s', 'rho_l', 'dt', 'df', 'phy', $
           'ICE', 'water', $
           'alt', $
           'C_land', 'C_ocean', 'C_icecover', $
           'W_land', 'W_ocean', 'W_icecover', $
           'I_land', 'I_ocean', 'I_icecover' $
           ]
no_el = n_elements(headerls)
odata = fltarr(no_el, no_yr_all) + missing

foreach each_hd, headerls, idx_hd do begin
  case each_hd of
    'time125k':odata[idx_hd, *] = time125k
    'hgt_icethick':odata[idx_hd, *] = hgt_icethick
    'r_land':odata[idx_hd, *] = r_land
    'r_ocean':odata[idx_hd, *] = r_ocean
    'r_icecover':odata[idx_hd, *] = r_icecover
    'dist':odata[idx_hd, *] = dist
    'oaff':odata[idx_hd, *] = oaff
    'mapid':odata[idx_hd, *] = mapid
    'Ta':odata[idx_hd, *] = Ta
    'Pr':odata[idx_hd, *] = Pr
    'critK':odata[idx_hd, *] = critK
    'k':odata[idx_hd, *] = k
    'tau':odata[idx_hd, *] = tau
    'CO2':odata[idx_hd, *] = CO2
    'lf':odata[idx_hd, *] = lf
    'soc':odata[idx_hd, *] = soc
    'Tamp':odata[idx_hd, *] = Tamp
    'TDD':odata[idx_hd, *] = TDD
    'FDD':odata[idx_hd, *] = FDD
    'FDD_snow':odata[idx_hd, *] = FDD_snow
    'numPF':odata[idx_hd, *] = numPF
    'gzai_1':odata[idx_hd, *] = gzai_1
    'gzai_2':odata[idx_hd, *] = gzai_2
    'Evap':odata[idx_hd, *] = Evap
    'Qs':odata[idx_hd, *] = Qs
    'Kt_dry':odata[idx_hd, *] = Kt_dry
    'Kt':odata[idx_hd, *] = Kt
    'Kf':odata[idx_hd, *] = Kf
    'rho_s':odata[idx_hd, *] = rho_s
    'rho_l':odata[idx_hd, *] = rho_l
    'dt':odata[idx_hd, *] = dt
    'df':odata[idx_hd, *] = df
    'phy':odata[idx_hd, *] = phy
    'ICE':odata[idx_hd, *] = ICE
    'water':odata[idx_hd, *] = water
    'alt':odata[idx_hd, *] = alt
    'C_land':odata[idx_hd, *] = C_land
    'C_ocean':odata[idx_hd, *] = C_ocean
    'C_icecover':odata[idx_hd, *] = C_icecover
    'W_land':odata[idx_hd, *] = W_land
    'W_ocean':odata[idx_hd, *] = W_ocean
    'W_icecover':odata[idx_hd, *] = W_icecover
    'I_land':odata[idx_hd, *] = I_land
    'I_ocean':odata[idx_hd, *] = I_ocean
    'I_icecover':odata[idx_hd, *] = I_icecover
  endcase
endforeach ;; each_hd
  
WRITE_CSV, f_out_csv, odata, HEADER = headerls

print, 'before=', flg_restart
if (flg_restart eq 0) then begin
  print, 'after=', flg_restart
;;for spinnup
  header2ls = [$
              'time_spnnp', $
              'SOC_spnnp', 'Water_spnnp', 'ICE_spnnp', $
              'critK_spnnp', 'k_spnnp', $
              'Kt_dry_spnnp', 'Kt_spnnp', 'Kf_spnnp', $
              'dt_spnnp', 'df_spnnp', 'phy_spnnp', $
              'rho_s_spnnp', 'rho_l_spnnp', $
              'C_land_spnnp', 'C_ocean_spnnp', 'C_icecover_spnnp', $
              'W_land_spnnp', 'W_ocean_spnnp', 'W_icecover_spnnp', $
              'I_land_spnnp', 'I_ocean_spnnp', 'I_icecover_spnnp', $
              'gzai_1_spnnp', 'gzai_2_spnnp', 'Evap_spnnp', 'Qs_spnnp' $
              ]
  no_el = n_elements(header2ls)
  odata = fltarr(no_el, no_lp) + missing
  foreach each_hd, header2ls, idx_hd do begin
    case each_hd of
      'time_spnnp':odata[idx_hd, *] = time_spnnp
      'SOC_spnnp':odata[idx_hd, *] = SOC_spnnp
      'Water_spnnp':odata[idx_hd, *] = Water_spnnp
      'ICE_spnnp':odata[idx_hd, *] = ICE_spnnp
      'critK_spnnp':odata[idx_hd, *] = critK_spnnp
      'k_spnnp':odata[idx_hd, *] = k_spnnp
      'Kt_dry_spnnp':odata[idx_hd, *] = Kt_dry_spnnp
      'Kt_spnnp':odata[idx_hd, *] = Kt_spnnp
      'Kf_spnnp':odata[idx_hd, *] = Kf_spnnp
      'dt_spnnp':odata[idx_hd, *] = dt_spnnp
      'df_spnnp':odata[idx_hd, *] = df_spnnp
      'phy_spnnp':odata[idx_hd, *] = phy_spnnp
      'rho_s_spnnp':odata[idx_hd, *] = rho_s_spnnp
      'rho_l_spnnp':odata[idx_hd, *] = rho_l_spnnp
      'C_land_spnnp':odata[idx_hd, *] = C_land_spnnp
      'C_ocean_spnnp':odata[idx_hd, *] = C_ocean_spnnp
      'C_icecover_spnnp':odata[idx_hd, *] = C_icecover_spnnp
      'W_land_spnnp':odata[idx_hd, *] = W_land_spnnp
      'W_ocean_spnnp':odata[idx_hd, *] = W_ocean_spnnp
      'W_icecover_spnnp':odata[idx_hd, *] = W_icecover_spnnp
      'I_land_spnnp':odata[idx_hd, *] = I_land_spnnp
      'I_ocean_spnnp':odata[idx_hd, *] = I_ocean_spnnp
      'I_icecover_spnnp':odata[idx_hd, *] = I_icecover_spnnp
      'gzai_1_spnnp':odata[idx_hd, *] = gzai_1_spnnp
      'gzai_2_spnnp':odata[idx_hd, *] = gzai_2_spnnp
      'Evap_spnnp':odata[idx_hd, *] = Evap_spnnp
      'Qs_spnnp':odata[idx_hd, *] = Qs_spnnp
    endcase
  endforeach ;; each_hd
  
  WRITE_CSV, f_spnnp_out_csv, odata, HEADER = header2ls

endif ;;flg_restart==0

end
